#include "sed1335.h"
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>

//extern void GLCD_SetPixel(int x, int y, int color);

void GLCD_Rectangle(unsigned int x, unsigned int y, unsigned int b, unsigned int a, int color)
{
  unsigned int j; // zmienna pomocnicza
  // rysowanie linii pionowych (boki)
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j, color);
		GLCD_SetPixel(x + b - 1, y + j, color);
	}
  // rysowanie linii poziomych (podstawy)
  for (j = 0; j < b; j++)	{
		GLCD_SetPixel(x + j, y, color);
		GLCD_SetPixel(x + j, y + a - 1, color);
	}
}


void GLCD_Circle(unsigned int cx, unsigned int cy ,unsigned int radius, int color)
{
	int x, y, xchange, ychange, radiusError;
	x = radius;
	y = 0;
	xchange = 1 - 2 * radius;
	ychange = 1;
	radiusError = 0;
	while(x >= y) {
	  GLCD_SetPixel(cx+x, cy+y, color); 
	  GLCD_SetPixel(cx-x, cy+y, color); 
	  GLCD_SetPixel(cx-x, cy-y, color);
	  GLCD_SetPixel(cx+x, cy-y, color); 
	  GLCD_SetPixel(cx+y, cy+x, color); 
	  GLCD_SetPixel(cx-y, cy+x, color); 
	  GLCD_SetPixel(cx-y, cy-x, color); 
	  GLCD_SetPixel(cx+y, cy-x, color); 
	  y++;
	  radiusError += ychange;
	  ychange += 2;
	  if ( 2*radiusError + xchange > 0 ) {
	    x--;
		radiusError += xchange;
		xchange += 2;
		}
	}
}

#if DEBUGPIXEL
unsigned  int XList[520];
unsigned char YList[520];
void panic(void);
#endif

//
// Bresenham circle drawing
//
unsigned long GLCD_Circle2(unsigned int x0, unsigned int y0 ,unsigned int radius, int color)
  {
    int f = 1 - radius;
    int ddF_x = 1;
    int ddF_y = -2 * radius;
    int x = 0;
    int y = radius;
#if DEBUGPIXEL
	unsigned long pixCnt;
	unsigned int *pX = XList;
	unsigned char *pY = YList;
#endif
	 
    GLCD_SetPixel(x0, y0 + radius, color);
#if DEBUGPIXEL
	if (color) { *pX++ = x0; *pY++ = y0 + radius;}
	else if ((*pX++ != x0) || (*pY++ != y0 + radius)) panic();
#endif
    GLCD_SetPixel(x0, y0 - radius, color);
#if DEBUGPIXEL
	if (color) { *pX++ = x0; *pY++ = y0 - radius;}
	else if ((*pX++ != x0) || (*pY++ != y0 - radius)) panic();
#endif
    GLCD_SetPixel(x0 + radius, y0, color);
#if DEBUGPIXEL
	if (color) { *pX++ = x0 + radius; *pY++ = y0;}
	else if ((*pX++ != x0 + radius) || (*pY++ != y0)) panic();
#endif
    GLCD_SetPixel(x0 - radius, y0, color);
#if DEBUGPIXEL
	if (color) { *pX++ = x0 - radius; *pY++ = y0;}
	else if ((*pX++ != x0 - radius) || (*pY++ != y0)) panic();
 	pixCnt = 4;
#endif
 
    while(x < y)
    {
      // ddF_x == 2 * x + 1;
      // ddF_y == -2 * y;
      // f == x*x + y*y - radius*radius + 2*x - y + 1;
      if(f >= 0) 
      {
        y--;
        ddF_y += 2;
        f += ddF_y;
      }
      x++;
      ddF_x += 2;
      f += ddF_x;    
      GLCD_SetPixel(x0 + x, y0 + y, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 + x; *pY++ = y0 + y;}
	  else if ((*pX++ != x0 + x) || (*pY++ != y0 + y)) panic();
#endif
      GLCD_SetPixel(x0 - x, y0 + y, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 - x; *pY++ = y0 + y;}
	  else if ((*pX++ != x0 - x) || (*pY++ != y0 + y)) panic();
#endif
      GLCD_SetPixel(x0 + x, y0 - y, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 + x; *pY++ = y0 - y;}
	  else if ((*pX++ != x0 + x) || (*pY++ != y0 - y)) panic();
#endif
      GLCD_SetPixel(x0 - x, y0 - y, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 - x; *pY++ = y0 - y;}
	  else if ((*pX++ != x0 - x) || (*pY++ != y0 - y)) panic();
#endif
      GLCD_SetPixel(x0 + y, y0 + x, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 + y; *pY++ = y0 + x;}
	  else if ((*pX++ != x0 + y) || (*pY++ != y0 + x)) panic();
#endif
      GLCD_SetPixel(x0 - y, y0 + x, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 - y; *pY++ = y0 + x;}
	  else if ((*pX++ != x0 - y) || (*pY++ != y0 + x)) panic();
#endif
      GLCD_SetPixel(x0 + y, y0 - x, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 + y; *pY++ = y0 - x;}
	  else if ((*pX++ != x0 + y) || (*pY++ != y0 - x)) panic();
#endif
      GLCD_SetPixel(x0 - y, y0 - x, color);
#if DEBUGPIXEL
	  if (color) { *pX++ = x0 - y; *pY++ = y0 - x;}
	  else if ((*pX++ != x0 - y) || (*pY++ != y0 - x)) panic();
	  pixCnt += 8;
#endif
	  
    }
#if DEBUGPIXEL
	return pixCnt;
#else
	return 0;
#endif
}





void GLCD_Line(int X1, int Y1,int X2,int Y2, int color)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

	Dx = (X2-X1); // obliczenie skadowej poziomej
	Dy = (Y2-Y1); // obliczenie skadowej pionowej

	TwoDx = Dx + Dx; // podwojona skadowa pozioma
	TwoDy = Dy + Dy; // podwojona skadowa pionowa

	CurrentX = X1; // zaczynamy od X1
	CurrentY = Y1; // oraz Y1

	Xinc = 1; // ustalamy krok zwikszania pozycji w poziomie 
	Yinc = 1; // ustalamy krok zwikszania pozycji w pionie

	if(Dx < 0) // jesli skadowa pozioma jest ujemna 
	{
	  Xinc = -1; // to bdziemy si "cofa" (krok ujemny)
	  Dx = -Dx;  // zmieniamy znak skadowej na dodatni
	  TwoDx = -TwoDx; // jak rwnie podwojonej skadowej
	}

	if (Dy < 0) // jeli skadowa pionowa jest ujemna
	  {
	  Yinc = -1; // to bdziemy si "cofa" (krok ujemny)
	  Dy = -Dy; // zmieniamy znak skadowej na dodatki
	  TwoDy = -TwoDy; // jak rwniez podwojonej skadowej
	  }

	GLCD_SetPixel(X1,Y1, color); // stawiamy pierwszy krok (zapalamy pierwszy piksel)

	if ((Dx != 0) || (Dy != 0)) // sprawdzamy czy linia skada si z wicej ni jednego punktu ;)
	  {
	  // sprawdzamy czy skadowa pionowa jest mniejsza lub rwna skadowej poziomej
	  if (Dy <= Dx) // jeli tak, to idziemy "po iksach"
	    { 
	    TwoDxAccumulatedError = 0; // zerujemy zmienn 
	    do // ruszamy w drog
		  {
	      CurrentX += Xinc; // do aktualnej pozycji dodajemy krok 
	      TwoDxAccumulatedError += TwoDy; // a tu dodajemy podwojon skadow pionow
	      if(TwoDxAccumulatedError > Dx)  // jeli TwoDxAccumulatedError jest wikszy od Dx
	        {
	        CurrentY += Yinc; // zwikszamy aktualn pozycj w pionie
	        TwoDxAccumulatedError -= TwoDx; // i odejmujemy TwoDx
	        }
	       GLCD_SetPixel(CurrentX,CurrentY, color);// stawiamy nastpny krok (zapalamy piksel)
	       }while (CurrentX != X2); // idziemy tak dugo, a osigniemy punkt docelowy
	     }
	   else // w przeciwnym razie idziemy "po igrekach" 
	      {
	      TwoDyAccumulatedError = 0; 
	      do 
		    {
	        CurrentY += Yinc; 
	        TwoDyAccumulatedError += TwoDx;
	        if(TwoDyAccumulatedError>Dy) 
	          {
	          CurrentX += Xinc;
	          TwoDyAccumulatedError -= TwoDy;
	          }
	         GLCD_SetPixel(CurrentX,CurrentY, color); 
	         }while (CurrentY != Y2);
	    }
	}
}
