; Flashtabs.asm - included source for Dutchtronix Oscilloscope Clock
;
;  Copyright  2008 Johannes P.M. de Rie
;
;  All Rights Reserved
;
;  This file is part of the Dutchtronix Oscilloscope Clock Distribution.
;  Use, modification, and re-distribution is permitted subject to the
;  terms in the file named "LICENSE.TXT", which contains the full text
;  of the legal notices and should always accompany this Distribution.
;
;  This software is provided "AS IS" with NO WARRANTY OF ANY KIND.
;
;  This notice (including the copyright and warranty disclaimer)
;  must be included in all copies or derivations of this software.
;
; Firmware for Dutchtronix AVR Oscilloscope Clock
;
; Flash Based Tables
;
; Menu String Scan Table Image
;
MTabImage:
	.dw	MsgPszLogo*2					;Logo Text
	.db	LOGOHPOS,LOGOVPOS

	.dw	MsgPszVersion*2
	.db	LOGOHPOS+12*DEFCHARWIDTH,LOGOVPOS

	.dw	TMenuNumeric*2					;Numeric Text
	.db	MENUHPOS,MENU0VPOS

	.dw	0								;Numeric Value
	.db	MENUHPOS+4*DEFCHARWIDTH,MENU0VPOS

	.dw	TMenuDial*2						;Dial Text
	.db	MENUH2POS,MENU0VPOS

	.dw	0								;Dial Value
	.db	MENUH2POS+5*DEFCHARWIDTH,MENU0VPOS

	.dw	TMenuGPS*2						;GPS Text
	.db	MENUHPOS,MENU1VPOS

	.dw	0								;GPS value
	.db	MENUHPOS+4*DEFCHARWIDTH,MENU1VPOS

	.dw	TMenuDST*2						;DST Text
	.db	MENUH2POS,MENU1VPOS

	.dw	0								;DST value
	.db	MENUH2POS+4*DEFCHARWIDTH,MENU1VPOS

#if MULTIAPP
	.dw	TMenuApp*2						;App choice Text
	.db	MENUHPOS,MENU2VPOS

	.dw	0								;App value
	.db	MENUHPOS+4*DEFCHARWIDTH,MENU2VPOS

#else
	.dw	TMenuBoot*2						;Reboot Text
	.db	MENUHPOS,MENU2VPOS
#endif

	.dw	TMenuDemo*2						;Demo Text
	.db	MENUH2POS,MENU2VPOS

	.dw	TMenuChrono*2					;Chrono Text
	.db	MENUHPOS,MENU3VPOS

	.dw	0								;Chrono value
	.db	MENUHPOS+7*DEFCHARWIDTH,MENU3VPOS

	.dw	TMenuCal*2						;Cal Text
	.db	MENUH2POS,MENU3VPOS

	.dw	0								;Cal Value
	.db	MENUH2POS+4*DEFCHARWIDTH,MENU3VPOS

	.dw	TMenuLed*2						;Led Text
	.db	MENUHPOS,MENU4VPOS

	.dw	0								;Led Value
	.db	MENUHPOS+4*DEFCHARWIDTH,MENU4VPOS

	.dw	TMenuBurnin*2					;BurnIn Text
	.db	MENUH2POS,MENU4VPOS

	.dw	0								;BurnIn Value
	.db	MENUH2POS+7*DEFCHARWIDTH,MENU4VPOS

	.dw	TMenuPlay*2						;Play Mode Text
	.db	MENUHPOS,MENU5VPOS

	.dw	0								;Play Value
	.db	MENUHPOS+5*DEFCHARWIDTH,MENU5VPOS

	.dw	TMenuReset*2						;Reset Text
	.db	MENUH2POS,MENU5VPOS

	.dw	0								;Reset Value
	.db	MENUH2POS+6*DEFCHARWIDTH,MENU5VPOS

#if MULTIBAUD
	.dw	TMenuBaud*2						;Baud Rate Text
	.db	MENUHPOS,MENU6VPOS

	.dw	0								;Baud Rate Value
	.db	MENUHPOS+5*DEFCHARWIDTH,MENU6VPOS
#endif

	.dw	TMenuUsrName*2					;User Name Text
	.db	MENUH2POS,MENU6VPOS

	.dw	0								;User Name Value
	.db	MENUH2POS+5*DEFCHARWIDTH,MENU6VPOS

	.dw	UsrNameBuf						;Editable User Name, in SRam
	.db	MENUHPOS, MENU7VPOS

MTabImageEnd:

;TMenuLogo:		.db	"Dutchtronix",0
;TMenuVersion:	.db	"V3.0",0,0
#if MULTIAPP
TMenuApp:		.db	"App",0
TMenuClock:		.db	"Clock",0
TMenuTerm:		.db	"Term",0,0
TMenuGen:		.db	"Gen",0
#endif
TMenuBoot:		.db	"Boot",0,0
TMenuDemo:		.db	"Demo",0,0
TMenuCal:		.db	"Cal",0
TMenuNumeric:	.db	"Num",0
TMenuLed:		.db	"Led",0
TMenuBurnin:	.db	"Burnin",0,0
TMenuDial:		.db	"Dial",0,0
TMenuOn:		.db	"On",0,0
TMenuOff:		.db	"Off",0
TMenu12HR:		.db	"12hr",0,0
TMenu24HR:		.db	"24hr",0,0
TMenuHex:		.db	"Hex",0
TMenuDate:		.db	"Date",0,0
TMenuBinary:	.db	"Bin",0
TMenuRoman:		.db	"Rom",0
TMenuMin:		.db	"Min",0
#if FUNMODES
TMenuPlay:		.db	"Play",0,0
TMenuNorm:		.db	"Norm",0,0
TMenuRev:		.db	"Rev",0
TMenuFastF:		.db	"FF",0,0
TMenuFastR:		.db	"FR",0,0
#endif		;FUNMODES
TMenuUsrName:	.db	"Name",0,0
TMenuEdit:		.db	"Edit",0,0
TPushToStart:	.db	"Push To Start",0

TMenuGPS:		.db	"GPS",0
TMenuGPSVals:	.db	"Off",0
TMenumin12hr:	.db	"-12",0
TMenumin11hr:	.db	"-11",0
TMenumin10hr:	.db	"-10",0
TMenumin9hr:	.db	"-9 ",0
TMenumin8hr:	.db	"-8 ",0
TMenumin7hr:	.db	"-7 ",0
TMenumin6hr:	.db	"-6 ",0
TMenumin5hr:	.db	"-5 ",0
TMenumin4hr:	.db	"-4 ",0
TMenumin3hr:	.db	"-3 ",0
TMenumin2hr:	.db	"-2 ",0
TMenumin1hr:	.db	"-1 ",0
TMenumin0hr:	.db	"0  ",0
TMenuplus1hr:	.db	"+1 ",0
TMenuplus2hr:	.db	"+2 ",0
TMenuplus3hr:	.db	"+3 ",0
TMenuplus4hr:	.db	"+4 ",0
TMenuplus5hr:	.db	"+5 ",0
TMenuplus6hr:	.db	"+6 ",0
TMenuplus7hr:	.db	"+7 ",0
TMenuplus8hr:	.db	"+8 ",0
TMenuplus9hr:	.db	"+9 ",0
TMenuplus10hr:	.db	"+10",0
TMenuplus11hr:	.db	"+11",0
TMenuplus12hr:	.db	"+12",0

TMenuDST:		.db	"DST",0
TMenuChrono:	.db	"Chrono",0,0
TMenuReset:		.db	"Reset",0


#if MULTIBAUD
TMenuBaud:		.db	"Baud",0,0
TMenuBaudVals:	.db	"19200 ",0,0
TMenuBaud28:	.db	"28800 ",0,0
TMenuBaud38:	.db	"38400 ",0,0
TMenuBaud57:	.db	"57600 ",0,0
TMenuBaud115:	.db	"115000",0,0
TMenuBaud48:	.db	"4800  ",0,0
TMenuBaud96:	.db	"9600  ",0,0
TMenuBaud14:	.db	"14400 ",0,0

MapBaudVal:
		.dw		64			;19,200
		.dw		42			;28,800
		.dw		32			;38,400
		.dw		21			;57,600
		.dw		10			;115,200
		.dw		259			;4800
		.dw		129			;9600
		.dw		86			;14,400
#endif
;
DialValTbl:
	.dw		TMenu12HR
#if DIAL24
	.dw		TMenu24HR
#else
	.dw		TMenu12HR
#endif
	.dw		TMenuRoman
	.dw		TMenuBinary
	.dw		TMenuMin

NumValTbl:
	.dw		TMenu12HR
	.dw		TMenu24HR
	.dw		TMenuHex
	.dw		TMenuDate
	.dw		TMenuOff

OffOnValTbl:
	.dw		TMenuOff
	.dw		TMenuOn

#if FUNMODES
PlayValTbl:
	.dw		TMenuNorm
	.dw		TMenuRev
	.dw		TMenuFastF
	.dw		TMenuFastR
#endif		; FUNMODES

OnOffValTbl:
UsrNameValTbl:
	.dw		TMenuOn
	.dw		TMenuOff
	.dw		TMenuEdit

DSTValTbl:
	.dw		TMenuUSA
	.dw		TMenuEU
	.dw		TMenuOff

TMenuUSA:
	.db		"USA",0
TMenuEU:
	.db		"EU",0,0

#if MULTIAPP
AppValTbl:
	.dw		TMenuClock
	.dw		TMenuTerm
	.dw		TMenuGen
	.dw		TMenuBoot
#endif

DemoText:
	.db		"Demo ",0

CharB:	.db	"B",0
CharP:	.db	"P",0
CharG:	.db	"G",0
;
; Menu Change Table: Action, Finalize, Flash
;
CMenuStateTbl:
	.dw		CMenuNextNumVal,		CMenuSaveNumVal,	MScanTbl_DialVal		;Numeric Field
	.dw		CMenuNextDialVal,		CMenuSaveDialVal,	MScanTbl_GPSVal			;Dial field
	.dw		CMenuNextGPSVal,		CMenuSaveGPSVal,	MScanTbl_DSTVal			;GPS field
#if MULTIAPP
	.dw		CmenuNextDSTVal,		CMenuSaveDSTVal,	MScanTbl_AppVal			;DST field
	.dw		CMenuNextAppVal,		CMenuSaveAppVal,	MScanTbl_Demo			;App field
#else
	.dw		CmenuNextDSTVal,		CMenuSaveDSTVal,	MScanTbl_Boot			;DST field
	.dw		InitiateSysReset,		CMenuDummy,			MScanTbl_Demo
#endif
	.dw		UsrDemo,				CMenuDummy,			MScanTbl_ChronoVal
	.dw		CMenuNextChronoVal,		CMenuSaveChronoVal,	MScanTbl_CalVal			;Chrono field
	.dw		CMenuNextCalVal,		CMenuSaveCalVal,	MScanTbl_LedVal
	.dw		CMenuNextLedVal,		CMenuSaveLedVal,	MScanTbl_BurninVal
	.dw		CMenuNextBurninVal,		CMenuSaveBurninVal, MScanTbl_PlayVal
	.dw		CMenuNextPlayVal,		CMenuSavePlayVal,	MScanTbl_InitVal
#if MULTIBAUD
	.dw		CMenuNextInitVal,		CMenuSaveInitVal,	MScanTbl_BaudVal		;Init field
	.dw		CMenuNextBaudVal,		CMenuSaveBaudVal,	MScanTbl_UsrNameVal		;Baud rate field
#else
	.dw		CMenuNextInitVal,		CMenuSaveInitVal,	MScanTbl_UsrNameVal		;Init field
#endif
	.dw		CMenuNextUsrNameVal,	CmenuSaveUsrNameVal,MScanTbl_UsrNameTxt
	.dw		CMenuIncUserNameChar,	CmenuNextUserNameChar,NULL
CMenuStateTableEnd:

CModStateTable:
	.db	CMODPREHRNR,CMODHRNR
	.dw	StateSetHRNR, STRINGFLASH|HourInString

	.db	CMODHRNR, CMODMINNR
	.dw	StateIncHr, STRINGFLASH|MinInString
	
	.db	CMODMINNR, CMODSECNR
	.dw	StateIncMin, STRINGFLASH|SecInString

	.db	CMODSECNR, CMODPRESET|NOPUSH	;advance immediately
	.dw	StateIncSec, 0

	.db	CMODPREHRHAND, CMODHRHAND
	.dw	StateSetHRHAND, ScanTbl_HrHand

	.db	CMODHRHAND, CMODMINHAND
	.dw	StateIncHr,	ScanTbl_MinHand

	.db	CMODMINHAND, CMODSECHAND
	.dw	StateIncMin, ScanTbl_SecHand

	.db	CMODSECHAND, CMODPRESET|NOPUSH	;advance immediately
	.dw	StateIncSec, NULL

	.db	CMODPREHRBIN, CMODHRBIN
	.dw	StateSetHRBIN, DOUBLESTRING|ScanTbl_HrHand

	.db	CMODHRBIN, CMODMINBIN
	.dw	StateIncHr, DOUBLESTRING|ScanTbl_MinHand

	.db	CMODMINBIN, CMODSECBIN
	.dw	StateIncMin, DOUBLESTRING|ScanTbl_SecHand

	.db	CMODSECBIN, CMODPRESET|NOPUSH	;advance immediately
	.dw	StateIncSec, NULL

	.db	CMODPREYEAR, CMODYEAR
	.dw	StateSetYEAR, STRINGFLASH|YearInString

	.db	CMODYEAR, CMODMONTH 
	.dw	StateIncYear, STRINGFLASH|MonthInString

	.db	CMODMONTH, CMODPREDAY|NOPUSH	;advance immediately
	.dw	StateIncMonth, NULL

	.db	CMODPREDAY, CMODDAY
	.dw	StateSetDay, STRINGFLASH|DayInString

	.db	CMODDAY, CMODDATESET|NOPUSH		;advance immediately
	.dw	StateIncDay, 0

	.db	CMODDATESET, CMODIDLE
	.dw	StateSetDate, NULL

	.db	CMODPRESET, CMODSET
	.dw StateSetMODSET, ScanTbl_Str1

	.db	CMODSET, CMODCANCEL|NOPUSH		;advance immediately
	.dw	StateSetTime,0

	.db	CMODCANCEL,0
	.dw	CTimeCancel,0
CModStateTableEnd:

;
; Daylight Saving Time Tables
;
; Source: http://webexhibits.org/daylightsaving/b.html
;
; Supported years: 2008-2014 (7 years. Can't do 8 years with bitvectors in EEProm)
; Data for 2008 (index 0) to 2014 (index 6).
; High nibble is date in March.
; Low nibble is date in November (US) or October (EU)
; EU dates are base 25
;
DSTUSData:	.db	9*16+2, 8*16+1, 14*16+7, 13*16+6, 11*16+4, 10*16+3, 9*16+2, 0
DSTEUData:	.db	5*16+1, 4*16+0,  3*16+6,  2*16+5,  0*16+3,  6*16+2, 5*16+1, 0
;
; Vector drawing tables
; Make sure to NOT use the ESCAPE char
;
BinaryFrameData: .db 12,0xf8, 12,BINVPOS0-35,0xf8, BINVPOS0-35,0xf8,0xf8, 12,0xf8, 0xff,0
CalibrationData: .db 0x01,0xfe,0x01,0x01,0xfe,0x01,0xfe,0xfe,0x01,0xfe,0xfe,0x01,0x01,0x01,0xfe,0xfe,0x01,0xfe,0x01,0x01,0xfe,0x01,0xfe,0xfe, 0xff,0
Led2Tbl:	.dw	Led2Tbl_0,Led2Tbl_1,Led2Tbl_2
Led2Tbl_0:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,0xff,0
Led2Tbl_1:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,0xff,0
Led2Tbl_2:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x7F,0xff,0
Led3Tbl:	.dw	Led3Tbl_0,Led3Tbl_1,Led3Tbl_2,Led3Tbl_3,Led3Tbl_4,Led3Tbl_5
Led3Tbl_0:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,0xff
Led3Tbl_1:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,0xff
Led3Tbl_2:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x4F,0xff
Led3Tbl_3:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x4F,0xff
Led3Tbl_4:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x7F,0xff
Led3Tbl_5:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x7F,0xff
Led4Tbl:	.dw	Led4Tbl_0,Led4Tbl_1,Led4Tbl_2,Led4Tbl_3,Led4Tbl_4,Led4Tbl_5,Led4Tbl_6,Led4Tbl_7,Led4Tbl_8,Led4Tbl_9
Led4Tbl_0:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_1:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_2:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_3:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_4:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x7F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_5:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x7F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_6:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x7F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_7:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x7F,ESCAPE,BINVPOS2,0x7F,ESCAPE,BINVPOS3,0x4F,0xff,0
Led4Tbl_8:		.db	ESCAPE,BINVPOS0,0x4F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x7F,0xff,0
Led4Tbl_9:		.db	ESCAPE,BINVPOS0,0x7F,ESCAPE,BINVPOS1,0x4F,ESCAPE,BINVPOS2,0x4F,ESCAPE,BINVPOS3,0x7F,0xff,0


ASC_TAB:	.db	"0123456789ABCDEF"
;
; map 24-hour hours to AM/PM hours
;
AMPMMapping:		.db	12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11
RotationTable:		.db	0,0, 1,0, 1,1, 0,1, -1,1, -1,0, -1,-1, 0,-1	;+1,-1
MonthsText:			.db	"Jan",31
					.db	"Feb",28
					.db	"Mar",31
					.db	"Apr",30
					.db	"May",31
					.db	"Jun",30
					.db	"Jul",31
					.db	"Aug",31
					.db	"Sep",30
					.db	"Oct",31
					.db	"Nov",30
					.db	"Dec",31

;
; Image data in the form of vectors (coordinate pairs)
;
.include	".\VectTable.asm"
.include	".\font8x5.asm"
